@if defined echo (echo %echo% ) else echo off
setlocal

set CURRENT_DIR=%~dp0
set /a count=0
set args=%*
for %%f in (%args%) do set /a count+=1
set /a argcount=0 
set JVMARGS=
set ISMPARGS=
set SILENT_INSTALL=false
if %count% == 0 goto FINISH_PROCESS_PARAMS

:PARAMS_LOOP
     
     if '%1' == '-D' goto COMPOSE_JVM_PARAMS
     if '%1' == '-Djava.io.tmpdir' goto COMPOSE_JVM_PARAMS_2
     goto COMPOSE_ISMP_PARAMS

:COMPOSE_JVM_PARAMS
     set JVMARGS=%JVMARGS% -D%2=%3
     shift
     shift
     shift
     set /a argcount+=3
	if %argcount% == %count%  goto FINISH_PROCESS_PARAMS 
     goto PARAMS_LOOP
     
:COMPOSE_JVM_PARAMS_2
     set JVMARGS=%JVMARGS% %1=%2
     shift
     shift
     set /a argcount+=2
	if %argcount% == %count%  goto FINISH_PROCESS_PARAMS 
     goto PARAMS_LOOP
     
:COMPOSE_ISMP_PARAMS
	set ISMPARGS=%ISMPARGS% %1
	if '%1' == '-OPT' goto COMPOSE_ISMP_PARAMS_2
	if '%1' == '-P' goto COMPOSE_ISMP_PARAMS_2
	if '%1' == '-W' goto COMPOSE_ISMP_PARAMS_2
:COMPOSE_ISMP_PARAMS_RETURN
	if '%1' == '-silent' set SILENT_INSTALL=true
	shift

	set /a argcount+=1

	if %argcount% == %count%  goto FINISH_PROCESS_PARAMS 
	if '%1' == ''  goto FINISH_PROCESS_PARAMS 
     goto PARAMS_LOOP

:COMPOSE_ISMP_PARAMS_2
	set ISMPARGS=%ISMPARGS% %2=%3
	shift
	shift
	goto COMPOSE_ISMP_PARAMS_RETURN
     
:FINISH_PROCESS_PARAMS

IF NOT EXIST "%CURRENT_DIR%update.jar" GOTO NoUpdateJar
IF EXIST "%CURRENT_DIR%java\jre\bin\java.exe" GOTO launchWithUPDIJavaJre
IF EXIST "%CURRENT_DIR%java\bin\java.exe" GOTO launchWithUPDIJava
IF EXIST "%CURRENT_DIR%jre\bin\java.exe" GOTO launchWithUPDIJre
GOTO JavaHomeNotFound

:launchWithUPDIJavaJre
set updiJAVAHOME=%CURRENT_DIR%java\jre
GOTO launchWithJAVAHOME

:launchWithUPDIJava
set updiJAVAHOME=%CURRENT_DIR%java
GOTO launchWithJAVAHOME

:launchWithUPDIJre
set updiJAVAHOME=%CURRENT_DIR%jre
GOTO launchWithJAVAHOME

:NoUpdateJar
echo
echo	Did not find file update.jar.
echo	Exiting
echo
GOTO END

:JavaHomeNotFound
echo
echo	Did not find JAVA_HOME under the updateinstaller directory.
echo	Exiting
echo
GOTO END

:launchWithJAVAHOME
set PATH=%updiJAVAHOME%\bin
set WindowsLAF=com.sun.java.swing.plaf.windows.WindowsLookAndFeel

if "%SILENT_INSTALL%" == "true" GOTO launchSilently
echo start /B javaw.exe  -Dswing.defaultlaf=%WindowsLAF% -cp "%CURRENT_DIR%update.jar" -Xms128m -Xmx512m %JVMARGS% run %ISMPARGS%
start /B javaw.exe  -Dswing.defaultlaf=%WindowsLAF% -cp "%CURRENT_DIR%update.jar" -Xms128m -Xmx512m %JVMARGS% run %ISMPARGS%
GOTO END

:launchSilently
echo java.exe  -Dswing.defaultlaf=%WindowsLAF% -cp "%CURRENT_DIR%update.jar" -Xms128m -Xmx512m  %JVMARGS% run %ISMPARGS%
java.exe  -Dswing.defaultlaf=%WindowsLAF% -cp "%CURRENT_DIR%update.jar" -Xms128m -Xmx512m  %JVMARGS% run %ISMPARGS%
GOTO END

:END
Echo.
endlocal exit /b %errorlevel%